> ## Documentation Index
> Fetch the complete documentation index at: https://docs.onset.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List milestones

> Retrieve a paginated list of milestones with optional filtering by status, visibility, project, and other criteria



## OpenAPI

````yaml https://api.onset.io/v1/openapi.yml get /milestones
openapi: 3.1.0
info:
  title: Onset API
  description: >-
    RESTful API for managing milestones, releases, subscribers, and webhooks in
    Onset workspace.
  version: 1.0.0
  contact:
    name: Onset Support
    url: https://www.onset.io
    email: support@onset.io
  license:
    name: MIT
    url: https://opensource.org/licenses/MIT
servers:
  - url: https://api.onset.io/v1
    description: API V1
security:
  - bearerAuth: []
  - basicAuth: []
tags:
  - name: Workspace
    description: Workspace management operations
  - name: Milestones
    description: Milestone management operations
  - name: Releases
    description: Release management operations
  - name: Subscribers
    description: Subscriber management operations
  - name: Webhooks
    description: Webhook management operations
  - name: Incoming Webhooks
    description: Incoming webhook management operations
paths:
  /milestones:
    get:
      tags:
        - Milestones
      summary: List milestones
      description: >-
        Retrieve a paginated list of milestones with optional filtering by
        status, visibility, project, and other criteria
      parameters:
        - name: offset
          in: query
          description: Number of items to skip for pagination (0-based)
          schema:
            type: integer
            minimum: 0
            maximum: 1000
            default: 0
            example: 0
        - name: limit
          in: query
          description: Maximum number of items to return per page
          schema:
            type: integer
            minimum: 1
            maximum: 100
            default: 10
            example: 25
        - name: slug
          in: query
          description: Filter by milestone slug (exact match)
          schema:
            type: string
            example: user-authentication-v2
        - name: is_public
          in: query
          description: Filter by public visibility status
          schema:
            type: boolean
            example: true
        - name: status
          in: query
          description: Filter by milestone status
          schema:
            type: string
        - name: project_id
          in: query
          description: Filter by project ID
          schema:
            type: string
      responses:
        '200':
          description: List of milestones retrieved successfully
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/Milestone'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorized'
components:
  schemas:
    Milestone:
      type: object
      properties:
        id:
          type: string
          description: Unique milestone identifier
        title:
          type: string
          description: Milestone title
        body:
          type: string
          description: Milestone description/body content (HTML formatted)
        slug:
          type: string
          description: URL-friendly milestone identifier
        status:
          type: string
          description: Current milestone status
        stage:
          type: string
          description: Current milestone stage
        is_public:
          type: boolean
          description: Whether milestone is publicly visible
        upvote_count:
          type: integer
          description: Number of votes for this milestone
        project:
          allOf:
            - $ref: '#/components/schemas/Project'
            - nullable: true
        labels:
          type: array
          items:
            $ref: '#/components/schemas/Label'
        attachments:
          type: array
          items:
            $ref: '#/components/schemas/Attachment'
        created_at:
          type: string
          format: date-time
          description: When the milestone was created
        updated_at:
          type: string
          format: date-time
          description: When the milestone was last updated
    Project:
      type: object
      properties:
        id:
          type: string
          description: Unique project identifier
        name:
          type: string
          description: Project name
        slug:
          type: string
          description: Project slug
    Label:
      type: object
      properties:
        id:
          type: string
          description: Unique label identifier
        name:
          type: string
          description: Label name
        slug:
          type: string
          description: Label slug
        color:
          type: string
          description: Label color (hex code)
    Attachment:
      type: object
      discriminator:
        propertyName: type
      properties:
        id:
          type: string
          description: Unique attachment identifier
        type:
          type: string
          enum:
            - FILE
            - LINK
          description: Type of attachment
      oneOf:
        - $ref: '#/components/schemas/FileAttachment'
        - $ref: '#/components/schemas/LinkAttachment'
    ErrorResponse:
      type: object
      properties:
        error:
          type: string
          description: Error message
        details:
          type: object
          description: Additional error details
      required:
        - error
    FileAttachment:
      type: object
      properties:
        type:
          type: string
          enum:
            - FILE
        content:
          type: object
          properties:
            title:
              type: string
              description: File title
            url:
              type: string
              description: File URL path
            size:
              type: integer
              description: File size in bytes
            type:
              type: string
              description: MIME type of the file
    LinkAttachment:
      type: object
      properties:
        type:
          type: string
          enum:
            - LINK
        content:
          type: object
          properties:
            title:
              type: string
              nullable: true
              description: Link title
            url:
              type: string
              format: uri
              description: Link URL
  responses:
    BadRequest:
      description: Bad request - Invalid input parameters
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    Unauthorized:
      description: Unauthorized - Invalid or missing authentication
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````